#!/usr/bin/env python

# mintUpload
#	Clement Lefebvre <root@linuxmint.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.
#
# Changelog
# =========
#
# - Uses /etc/ for the services
# - Now supports FTP with optional path option
# - Now supports scp - jayemdaet
# - Now supports ssh/sftp - emorrp1
#

import sys

try:
    import pygtk
    pygtk.require("2.0")
except:
    pass
try:
    import gtk
    import gtk.glade
    import urllib
    import ftplib
    import os
    import threading
    import datetime
    import gettext
    import ssh
    import pexpect
except:
    print "You do not have all the dependencies!"
    sys.exit(1)

gtk.gdk.threads_init()

# i18n
gettext.install("messages", "/usr/lib/linuxmint/mintUpload/locale")

class ConnectionError(Exception):
    pass

class spaceChecker(threading.Thread):

    def run(self):
	global statusbar
	global context_id
	global wTree	
	global selected_service

	wTree.get_widget("combo").set_sensitive(False)
	wTree.get_widget("upload_button").set_sensitive(False)

	statusbar.push(context_id, _("Checking space on the service..."))
	wTree.get_widget("main_window").window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))		
	# Get the available space left on the service
	try:				
		spaceInfo = urllib.urlopen(selected_service['space']).read()
		spaceInfoArray = spaceInfo.split('/')	
		spaceAvailable = spaceInfoArray[0]
		spaceTotal = spaceInfoArray[1]
		pctSpace = float(spaceAvailable) / float(spaceTotal) * 100
		pctSpace = int(pctSpace)
		#spaceAvailableInMB = round(float(spaceAvailable) / 1000000, 2)
		spaceAvailable = float(spaceAvailable)
		spaceAvailableSTR = str(spaceAvailable) + _("B")
		if (spaceAvailable > 1000):
			spaceAvailableF = round(spaceAvailable/1000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("KB")
		if (spaceAvailable > 1000000):
			spaceAvailableF = round(spaceAvailable/1000000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("MB")
		if (spaceAvailable > 1000000000):
			spaceAvailableF = round(spaceAvailable/1000000000, 1)
			spaceAvailableSTR = str(spaceAvailableF) + _("GB")

		pctSpaceStr = spaceAvailableSTR + " (" + str(pctSpace) + "%)"
		wTree.get_widget("txt_space").set_label(pctSpaceStr)

		maxsize = float(selected_service['maxsize'])
		if (maxsize > 1000):
			maxsizeF = round(maxsize/1000, 1)
			maxsizeStr = str(maxsizeF) + _("KB")
		if (maxsize > 1000000):
			maxsizeF = round(maxsize/1000000, 1)
			maxsizeStr = str(maxsizeF) + _("MB")
		if (maxsize > 1000000000):
			maxsizeF = round(maxsize/1000000000, 1)
			maxsizeStr = str(maxsizeF) + _("GB")
		wTree.get_widget("txt_maxsize").set_label(maxsizeStr)	

		wTree.get_widget("txt_persistence").set_label(selected_service['persistence'] + " " + _("days"))	

		#Activate the upload button if the space is OK	
		if (spaceAvailable >= filesize and filesize <= maxsize):
			wTree.get_widget("upload_button").set_sensitive(True)
			statusbar.push(context_id, "<span color='green'>" + _("Service ready. Space available.") + "</span>")
			label = statusbar.get_children()[0].get_children()[0]		
			label.set_use_markup(True)
		else:
			wTree.get_widget("upload_button").set_sensitive(False)
			statusbar.push(context_id, "<span color='red'>" + _("File too big or not enough space on the service.") + "</span>")
			label = statusbar.get_children()[0].get_children()[0]		
			label.set_use_markup(True)
	except Exception, detail:
		print detail	
		statusbar.push(context_id, "<span color='red'>" + _("Could not connect to the service.") + "</span>")
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)
		wTree.get_widget("upload_button").set_sensitive(False)
		
	finally:
		wTree.get_widget("main_window").window.set_cursor(None)		
		wTree.get_widget("combo").set_sensitive(True)

class mintUploader(threading.Thread):

    def run(self):
	global so_far
	global filesize
	global progressbar
	global statusbar
	global selected_service
	global filename
	global wTree
	global url

	wTree.get_widget("combo").set_sensitive(False)
	wTree.get_widget("upload_button").set_sensitive(False)

	try:
		statusbar.push(context_id, _("Connecting to the service..."))
		wTree.get_widget("main_window").window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))		

		so_far = 0
		progressbar.set_fraction(0)
		progressbar.set_text("0%")

		# switch to required connect function, depending on service
		supported_services = {
		    'MINT': self._ftp,
		    'FTP' : self._ftp,
		    'SSH' : self._ssh,
		    'SFTP': self._ssh,
		    'SCP' : self._scp}[selected_service['type']]()

		progressbar.set_fraction(1)
		progressbar.set_text("100%")
		statusbar.push(context_id, "<span color='green'>" + _("File uploaded successfully.") + "</span>")
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)						
	except Exception, detail:
		print detail
		statusbar.push(context_id, "<span color='red'>" + _("Upload failed.") + "</span> -- " + str(detail).encode("ascii", ignore))
		label = statusbar.get_children()[0].get_children()[0]		
		label.set_use_markup(True)
	finally:
		wTree.get_widget("main_window").window.set_cursor(None)		
		wTree.get_widget("combo").set_sensitive(False)
		wTree.get_widget("upload_button").set_sensitive(False)

    def _ftp(self):
	try:
	    #attempting to connect
	    ftp = ftplib.FTP()
	    ftp.connect(selected_service['host'], 21)		
	    ftp.login(selected_service['user'], selected_service['pass'])	        
	    statusbar.push(context_id, _(selected_service['type'] + " connection successfully established"))

	    name = os.path.split(filename)[1]
	    f = open(filename, "rb")
	    statusbar.push(context_id, _("Uploading the file..."))
	    if (selected_service['path'] != "none"):
		    try:
			    ftp.mkd(selected_service['path'])
		    except:
			    pass
		    ftp.cwd(selected_service['path'])
	    if (selected_service['type'] == "MINT"):
		    timestamp = datetime.datetime.utcnow().strftime("%Y%m%d%H%M%S")
		    directory = ftp.mkd(timestamp)
		    ftp.cwd(directory)
	    ftp.storbinary('STOR ' + name, f, 1024, callback=self.asciicallback)
	    f.close()
	    ftp.quit()
	    if (selected_service['type'] == "MINT"):
		    url = ""
		    for urlPart in selected_service['url']:
			    url = url + "," + urlPart
		    url = url[1:]
		    url = url.replace("<TIMESTAMP>", timestamp)
		    url = url.replace("<FILE>", name)
		    wTree.get_widget("txt_url").set_text(url)
		    wTree.get_widget("copy_button").set_sensitive(True)
	    else:			
		    wTree.get_widget("txt_url").set_text(_("N/A"))
		    wTree.get_widget("copy_button").set_sensitive(False)
	except:
	    # close any open connections
	    f.close()
	    ftp.quit()
	    raise

    def _ssh(self):
	try:
	    #attempting to connect
	    myssh = ssh.Connection(selected_service['host'],selected_service['user'],selected_service['pass'])
	    statusbar.push(context_id, _(selected_service['type'] + " connection successfully established"))

	    path = selected_service['path']
	    if (path != "none"):
		try:
		    myssh.execute('mkdir ' + path)
		except:
		    pass
		name = os.path.split(filename)[1]
		myssh.put(filename,path + name)
	    else:
		myssh.put(filename)
	    myssh.close()
	    wTree.get_widget("txt_url").set_text(_("N/A"))
	    wTree.get_widget("copy_button").set_sensitive(False)
	except:
	    # close any open connections
	    myssh.close()
	    raise

    def _scp(self):
	try:
	    #attempting to connect
	    scp_cmd = "scp " + filename + " " + selected_service['user'] + "@" + selected_service['host'] + ':'
	    if (selected_service['path'] != "none"):
		scp_cmd += + selected_service['path']
	    else:
		scp_cmd += '.'
	    scp = pexpect.spawn(scp_cmd)
	    if (selected_service['pass'] != "none"):
		scp.expect('.*password:*')
		scp.sendline(selected_service['pass'])

	    statusbar.push(context_id, _(selected_service['type'] + " connection successfully established"))

	    scp.timeout = None
	    received = scp.expect(['.*100\%.*','.*password:.*',pexpect.EOF])
	    if (received == 1):
		scp.sendline(' ')
		raise ConnectionError("Connection requires a password!")
	    scp.close()
	    wTree.get_widget("txt_url").set_text(_("N/A"))
	    wTree.get_widget("copy_button").set_sensitive(False)
	except:
	    # close any open connections
	    scp.close()
	    raise

    def asciicallback(self, buffer):
	global so_far	
	global progressbar
	global filesize
	
	so_far = so_far+len(buffer)-1
	pct = float(so_far)/filesize
	progressbar.set_fraction(pct)
        pct = int(pct * 100)
	progressbar.set_text(str(pct) + "%")
	print "so far:", pct, "%"
	return

class mintUploadWindow:
    """This is the main class for the application"""

    def __init__(self, filename):
	global filesize
	global wTree
	global filesizeSTR

	self.filename = filename

	#Set the Glade file
        self.gladefile = "/usr/lib/linuxmint/mintUpload/mintUpload.glade"
        wTree = gtk.glade.XML(self.gladefile,"main_window")

	wTree.get_widget("main_window").connect("destroy", gtk.main_quit)

	#i18n
	wTree.get_widget("txt_name").set_label("<big><b>" + _("Upload a file") + "</b></big>")
	wTree.get_widget("txt_guidance").set_label("<i>" + _("Upload and share a file") + "</i>") 
	wTree.get_widget("label2").set_label("<b>" + _("Upload service") + "</b>")
	wTree.get_widget("label3").set_label("<b>" + _("Local file") + "</b>")
	wTree.get_widget("label4").set_label("<b>" + _("Remote file") + "</b>")
	wTree.get_widget("label187").set_label(_("Name:"))
	wTree.get_widget("label188").set_label(_("Free space:"))
	wTree.get_widget("label196").set_label(_("Max file size:"))
	wTree.get_widget("label198").set_label(_("Persistence:"))
	wTree.get_widget("label195").set_label(_("Path:"))
	wTree.get_widget("label193").set_label(_("Size:"))
	wTree.get_widget("label190").set_label(_("Upload progress:"))
	wTree.get_widget("label191").set_label(_("URL:"))
	
	services = self.read_services()
	for service in services:		
        	wTree.get_widget("combo").append_text(service['name'])
		    
	wTree.get_widget("combo").connect("changed", self.comboChanged)	
	wTree.get_widget("upload_button").connect("clicked", self.upload)	
	wTree.get_widget("copy_button").connect("clicked", self.copy)	
	wTree.get_widget("cancel_button").connect("clicked", gtk.main_quit)	

	# Print the name of the file in the GUI
	wTree.get_widget("txt_file").set_label(self.filename)

	# Calculate the size of the file
	filesize = os.path.getsize(self.filename)
	filesize = float(filesize)
	filesizeSTR = str(filesize) + _("B")
	if (filesize > 1000):
		filesizeF = round(filesize/1000, 1)
		filesizeSTR = str(filesizeF) + _("KB")
	if (filesize > 1000000):
		filesizeF = round(filesize/1000000, 1)
		filesizeSTR = str(filesizeF) + _("MB")
	if (filesize > 1000000000):
		filesizeF = round(filesize/1000000000, 1)
		filesizeSTR = str(filesizeF) + _("GB")
		
	wTree.get_widget("txt_size").set_label(filesizeSTR)

    def comboChanged(self, widget):	
	global progressbar
	global statusbar
	global wTree
	global context_id
	global selected_service

	progressbar = wTree.get_widget("progressbar")
	statusbar = wTree.get_widget("statusbar")
	context_id = statusbar.get_context_id("mintUpload")

	#Get the selected service
	model = wTree.get_widget("combo").get_model()
        active = wTree.get_widget("combo").get_active()
        if active < 0:
        	return
        selectedService = model[active][0]

	services = self.read_services()
	for service in services:						
		if (service['name'] == selectedService):			
			selected_service = service
			if (service['type'] == "MINT"):				
				spacecheck = spaceChecker()
				spacecheck.start()
			else:
				wTree.get_widget("txt_persistence").set_label(_("N/A"))
				wTree.get_widget("txt_space").set_label(_("N/A"))
				wTree.get_widget("txt_maxsize").set_label(_("N/A"))
				wTree.get_widget("upload_button").set_sensitive(True)
				statusbar.push(context_id, "<span color='green'>" + _(service['type'] + " service selected") + "</span>")
				label = statusbar.get_children()[0].get_children()[0]		
				label.set_use_markup(True)
			return True

    def read_services(self):	
	services = []
	os.system("mkdir -p /etc/linuxmint/mintUpload/services/")
	for file in os.listdir("/etc/linuxmint/mintUpload/services/"):	
		services.append(self.read_service("/etc/linuxmint/mintUpload/services/" + file))
	from user import home
	os.system("mkdir -p " + home + "/.linuxmint/mintUpload/services/")
	for file in os.listdir(home + "/.linuxmint/mintUpload/services/"):	
		services.append(self.read_service(home + "/.linuxmint/mintUpload/services/" + file))
	return services

    def read_service(self, path):
	from configobj import ConfigObj
        config = ConfigObj(path)
	service = {}		
	service["type"] = config['type'].upper()
	service["name"] = config['name']
	service["host"] = config['host']
	service["user"] = config['user']
	service["pass"] = config['pass']

	if (service["type"] == "MINT"):
		service["space"] = config['space']
		service["url"] = config['url']
		service["maxsize"] = config['maxsize']
		service["persistence"] = config['persistence']
	try:
		service["path"] = config['path'] + '/'
		service["path"].replace('//','/')
	except:
		service["path"] = "none"
        return service
			
    def upload(self, widget):
	global wTree

	#Upload the file
	wTree.get_widget("upload_button").set_sensitive(False)
	wTree.get_widget("combo").set_sensitive(False)
	uploader = mintUploader()
	uploader.start()
	return True

    def copy(self, widget):
	global url
	
	# get the clipboard
	clipboard = gtk.clipboard_get()
	clipboard.set_text(url)
	clipboard.store()

def my_storbinary(self, cmd, fp, blocksize=8192, callback=None):
    '''Store a file in binary mode.'''
    self.voidcmd('TYPE I')
    conn = self.transfercmd(cmd)
    while 1:
        buf = fp.read(blocksize)
        if not buf: break
        conn.sendall(buf)
	if callback: callback(buf)
    conn.close()
    return self.voidresp()

def my_storlines(self, cmd, fp, callback=None):
    '''Store a file in line mode.'''
    self.voidcmd('TYPE A')
    conn = self.transfercmd(cmd)
    while 1:
        buf = fp.readline()
        if not buf: break
        if buf[-2:] != CRLF:
            if buf[-1] in CRLF: buf = buf[:-1]
            buf = buf + CRLF
        conn.sendall(buf)
        if callback: callback(buf)
    conn.close()
    return self.voidresp()

ftplib.FTP.storbinary = my_storbinary  # use the patched version
ftplib.FTP.storlines = my_storlines  # use the patched version

if __name__ == "__main__":
    filename = sys.argv[1]
    mainwin = mintUploadWindow(filename)
    gtk.main()
    
